# TODO:
# - lua: enable after patching to use system lua modules:
#   - https://github.com/keplerproject/luafilesystem >= 1.6.3
#   - http://lua.sqlite.org/ >= 0.9.1 (0.9.3 preferred) + sqlite3 >= 3.8.9
#   - https://github.com/n1tehawk/LuaXML >= 1.8.0
#
# Conditional build:
%bcond_with	duktape		# Duktape support (fails to build)
%bcond_with	lua		# Lua support (see above)

Summary:	Embedded C/C++ web server
Summary(pl.UTF-8):	Osadzony serwer WWW dla C i C++
Name:		civetweb
Version:	1.16
Release:	1
License:	MIT
Group:		Libraries
#Source0Download: https://github.com/civetweb/civetweb/releases
Source0:	https://github.com/civetweb/civetweb/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	0a254d89564c2f5dea9914a492fbeb78
URL:		https://github.com/civetweb/civetweb
BuildRequires:	cmake >= 3.3.0
BuildRequires:	libstdc++-devel
%{?with_lua:BuildRequires:	lua-devel >= 5.1}
BuildRequires:	openssl-devel >= 3.0
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 2.047
BuildRequires:	zlib-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Project mission is to provide easy to use, powerful, C (C/C++)
embeddable web server with optional CGI, SSL and Lua support. CivetWeb
has a MIT license so you can innovate without restrictions.

CivetWeb can be used by developers as a library, to add web server
functionality to an existing application. It can also be used by end
users as a stand-alone web server running on a Windows or Linux PC. It
is available as single executable, no installation is required.

%description -l pl.UTF-8
Misją projektu jest dostarczenie łatwego w użyciu, bogatego w
możliwości, osadzalnego w C (C/C++) serwera WWW z opcjonalną obsługą
CGI, SSL i Lua. CivetWeb jest udostępniony na licencji MIT, więc można
go rozszerzać bez ograniczeń.

CivetWeb może być używany przez programistów jako biblioteka, aby
dodać funkcjonalność serwera WWW do istniejących aplikacji, a także
przez użytkowników końcowych jako samodzielny serwer, uruchamiany na
komputerach z Windows lub Linuksem. Jest dostępny jako samodzielna
binarka, nie wymaga instalacji.

%package devel
Summary:	Header files for CivetWeb library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki CivetWeb
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for CivetWeb library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki CivetWeb.

%package apidocs
Summary:	API documentation for CivetWeb library
Summary(pl.UTF-8):	Dokumentacja API biblioteki CivetWeb
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for CivetWeb library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki CivetWeb.

%package cpp
Summary:	C++ wrapper library for CivetWeb
Summary(pl.UTF-8):	Biblioteka opakowania C++ dla CivetWeb
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description cpp
C++ wrapper library for CivetWeb.

%description cpp -l pl.UTF-8
Biblioteka opakowania C++ dla CivetWeb.

%package cpp-devel
Summary:	Header file for CivetWeb C++ wrapper library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki opakowania C++ CivetWeb
Group:		Development/Libraries
Requires:	%{name}-cpp = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}

%description cpp-devel
Header file for CivetWeb C++ wrapper library.

%description cpp-devel -l pl.UTF-8
Plik nagłówkowy biblioteki opakowania C++ CivetWeb.

%prep
%setup -q

%build
# "build" file exists, use another dir name
install -d builddir
cd builddir
# .pc generation assumes dirs relative to CMAKE_INSTALL_PREFIX
# and pkgconfig dir is relative to CMAKE_INSTALL_DATADIR
%cmake .. \
	-DCMAKE_INSTALL_INCLUDEDIR=include \
	-DCMAKE_INSTALL_LIBDIR=%{_lib} \
	-DCMAKE_INSTALL_DATADIR=%{_lib} \
	-DCIVETWEB_BUILD_TESTING=OFF \
	-DCIVETWEB_ENABLE_CXX=ON \
	-DCIVETWEB_ENABLE_DUKTAPE=%{__ON_OFF lua} \
	-DCIVETWEB_ENABLE_LUA=%{__ON_OFF lua} \
	-DCIVETWEB_ENABLE_LUA_SHARED=%{__ON_OFF lua} \
	-DCIVETWEB_ENABLE_SERVER_STATS=ON \
	-DCIVETWEB_ENABLE_WEBSOCKETS=ON \
	-DCIVETWEB_ENABLE_ZLIB=ON \
	-DCIVETWEB_SSL_OPENSSL_API_1_1=OFF \
	-DCIVETWEB_SSL_OPENSSL_API_3_0=ON \

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C builddir install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	cpp -p /sbin/ldconfig
%postun	cpp -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CREDITS.md LICENSE.md README.md RELEASE_NOTES.md SECURITY.md
%attr(755,root,root) %{_bindir}/civetweb
%attr(755,root,root) %{_libdir}/libcivetweb.so.1.15.0

%files devel
%defattr(644,root,root,755)
%{_libdir}/libcivetweb.so
%{_includedir}/civetweb.h
%{_libdir}/cmake/civetweb
%{_pkgconfigdir}/civetweb.pc

%files apidocs
%defattr(644,root,root,755)
%doc docs/{api,*.md}

%files cpp
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcivetweb-cpp.so.1.15.0

%files cpp-devel
%defattr(644,root,root,755)
%{_libdir}/libcivetweb-cpp.so
%{_includedir}/CivetServer.h
%{_pkgconfigdir}/civetweb-cpp.pc
%changelog
* Sun Apr 27 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/civetweb.git;a=log;h=master

* Sun Apr 27 2025 Jakub Bogusz <qboosh@pld-linux.org> 6303f96
- new

